/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.controller.util.ErrorItem;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.InvalidPayModeException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableAddressException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableBankException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableCardException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.io.Serializable;
import java.util.HashMap;

public class AgencyUpdater extends SaveAdapter {

	public Serializable save(HashMap map) {

		try {

			if (inputTesting(map))				
				
			AgencyController.updateAgency((Long) map.get("id"), (Long) map.get("address"), (String) map.get("street"), (String) map.get("dwellingPlace"), 
					(String) map.get("phone1"), (String) map.get("phone2"), (String) map.get("fax"), (String) map.get("email"), (String) map.get("web"), (Long) map.get("bank"), (Long) map.get("card"), (String) map.get("notes"), 
					(String) map.get("cif"), (String) map.get("name"), (String) map.get("contact"), (String) map.get("payMode"), (String) map.get("accountNumber"), 
					(String) map.get("cardNumber"));
		
		} catch (InvalidPayModeException e) {
			e.printStackTrace();
		} catch (UnaceptableAddressException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("address"));		
		} catch (UnaceptableBankException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("bank"));
		} catch (UnaceptableCardException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("card"));		
		} catch (InstanceNotFoundException e) {
			e.printStackTrace();
		}  catch (InternalErrorException e) {			
			e.printStackTrace();
		}
		return (Long) map.get("id");
	}

	protected boolean inputTesting(HashMap map) {
		
		if (((Long) map.get("address")) == null) {		
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("address"));
			return false;
		}

		if (((String) map.get("name")).trim().equals("")) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("name"));
			return false;
		}				
		
		if (((String) map.get("cif")).trim().equals("")) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("cif"));
			return false;
		}
		
		ErrorsHandler.clear();

		return true;

	}

}
