/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.model.card.to.CardTo;
import gz.cyberbrain.cyberhotel.model.configurationfacade.delegate.ConfigurationFacadeDelegate;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.CardWithClientsException;
import gz.cyberbrain.cyberhotel.model.spring.facade.SpringFacadeFactory;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.ImageItem;

import java.io.Serializable;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.JPanel;

public class CardController {

	private static ConfigurationFacadeDelegate delegate = SpringFacadeFactory.getConfigurationFacadeDelegate();
	private static HashMap<String, String> attributes = new HashMap<String, String>();
	
	private CardController() {}
	
	public static Vector cardList() throws InternalErrorException {				
		Vector<JPanel> items = new Vector<JPanel>();
		Collection cards = delegate.showCards();
		Iterator iter = cards.iterator();

		CardTo card;

		for (int i=0; iter.hasNext(); i++) {

			card = (CardTo) iter.next();
			items.add(new ImageItem(card.getCardId(), card.getType(), card.getLogo()));

		}

		return items;
	}

	public static Serializable createCard(String name, String logo) throws InternalErrorException {
		return delegate.createCard(new CardTo(null, name, logo)).getCardId();
	}

	public static void updateCard(Long cardId, String name, String logo) throws InternalErrorException {
		delegate.updateCard(new CardTo(cardId, name, logo));
	}
	
	public static void deleteCard(Long cardId) throws InstanceNotFoundException, CardWithClientsException, InternalErrorException{
		CardTo card = delegate.findCard(cardId);
		delegate.deleteCard(card);
	}
	
	public static HashMap findCard(Long cardId) throws InstanceNotFoundException, InternalErrorException {
		CardTo card = delegate.findCard(cardId);
		
		attributes.put("name", card.getType());
		attributes.put("logo", card.getLogo());
		
		return attributes;
				
	}
	
}
