/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.controller.util.ErrorItem;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.invoicingfacade.spring.actions.PayedInvoiceException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Vector;

public class InvoiceListAdapter extends ListAdapter {

	public SaveAdapter getCreator() {
		return new InvoiceCreator();
	}

	public SaveAdapter getUpdater() {
		return new InvoiceUpdater();
	}

	public Vector load() {
		Vector list = new Vector();

		list = InvoiceController.invoiceList();

		return list;
	}

	public void delete(Serializable id) {
		
		//Parse the id (invoiceNumber/invoiceSerial)
		
		int separator = ((String)id).lastIndexOf("/");
		
		String invoiceNumber = ((String)id).substring(0, separator);
		String invoiceSerial = ((String)id).substring(separator + 1, ((String)id).length());
		
		try {
			InvoiceController.deleteInvoice(new Long(invoiceNumber), invoiceSerial);
			
		} catch (PayedInvoiceException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("payedInvoice"));
		} catch (InstanceNotFoundException e) {
			e.printStackTrace();
		} catch (InternalErrorException e) {
			e.printStackTrace();
		}

	}

	public HashMap find(Serializable id) {
		HashMap map = new HashMap();
		try {
			map = InvoiceController.findInvoice((String) id);
		} catch (InstanceNotFoundException e) {
		} catch (InternalErrorException e) {}
		return map;
	}

}
