/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.model.configurationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.RoomTypeInUseException;
import gz.cyberbrain.cyberhotel.model.roomtype.dao.RoomTypeDao;
import gz.cyberbrain.cyberhotel.model.roomtype.to.RoomTypeTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class DeleteRoomTypeAction {

	private RoomTypeTo roomTypeTo;
	private RoomTypeDao roomTypeDao;
	
	public DeleteRoomTypeAction (RoomTypeTo roomTypeTo, RoomTypeDao roomTypeDao) {
		
		this.roomTypeTo = roomTypeTo;
		this.roomTypeDao = roomTypeDao;
		
	}
	
	public void execute() throws RoomTypeInUseException, InternalErrorException {
		
		if (roomTypeDao.existRooms(roomTypeTo.getRoomTypeCode())) throw new RoomTypeInUseException(roomTypeTo);
		
		roomTypeDao.remove(roomTypeTo);
		
	}
	
}
