/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.model.invoice.to;

import gz.cyberbrain.cyberhotel.model.identifiable.Identifiable;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Calendar;

public class InvoiceTo implements Identifiable {

	private static final long serialVersionUID = 5148195112814139721L;
	private Long invoiceNumber;
	private String invoiceSerial;
	private Calendar invoiceDate;
	private String shipperName;
	private String shipperCif;
	private String shipperStreet;
	private Long payer;
	private String payMode;
	private BigDecimal subtotal;
	private BigDecimal quotaVat;
	private BigDecimal total;
	private String status;
	private String observations;
	
	public InvoiceTo(){}
	
	public InvoiceTo(Long invoiceNumber, String invoiceSerial, Calendar invoiceDate, String shipperName, String shipperCif, String shipperStreet, Long payer, String payMode, BigDecimal subtotal, BigDecimal quotaVat, BigDecimal total, String status, String observations) {		
		this.invoiceNumber = invoiceNumber;
		this.invoiceSerial = invoiceSerial;
		this.invoiceDate = invoiceDate;
		this.shipperName = shipperName;
		this.shipperCif = shipperCif;
		this.shipperStreet = shipperStreet;
		this.payer = payer;
		this.payMode = payMode;
		this.subtotal = subtotal;
		this.quotaVat = quotaVat;
		this.total = total;
		this.status = status;
		this.observations = observations;
	}
	
	public Serializable getId(){
		return new String(invoiceNumber + "/" + invoiceSerial);
	}

	public Calendar getInvoiceDate() {
		return invoiceDate;
	}

	public void setInvoiceDate(Calendar invoiceDate) {
		this.invoiceDate = invoiceDate;
	}

	public Long getInvoiceNumber() {
		return invoiceNumber;
	}

	public void setInvoiceNumber(Long invoiceNumber) {
		this.invoiceNumber = invoiceNumber;
	}

	public String getInvoiceSerial() {
		return invoiceSerial;
	}

	public void setInvoiceSerial(String invoiceSerial) {
		this.invoiceSerial = invoiceSerial;
	}

	public String getObservations() {
		return observations;
	}

	public void setObservations(String observations) {
		this.observations = observations;
	}

	public Long getPayer() {
		return payer;
	}

	public void setPayer(Long payer) {
		this.payer = payer;
	}

	public String getPayMode() {
		return payMode;
	}

	public void setPayMode(String payMode) {
		this.payMode = payMode;
	}

	public BigDecimal getQuotaVat() {
		return quotaVat;
	}

	public void setQuotaVat(BigDecimal quotaVat) {
		this.quotaVat = quotaVat;
	}

	public String getShipperCif() {
		return shipperCif;
	}

	public void setShipperCif(String shipperCif) {
		this.shipperCif = shipperCif;
	}

	public String getShipperName() {
		return shipperName;
	}

	public void setShipperName(String shipperName) {
		this.shipperName = shipperName;
	}

	public String getShipperStreet() {
		return shipperStreet;
	}

	public void setShipperStreet(String shipperStreet) {
		this.shipperStreet = shipperStreet;
	}

	public String getStatus() {
		return status;
	}

	public void setStatus(String status) {
		this.status = status;
	}

	public BigDecimal getSubtotal() {
		return subtotal;
	}

	public void setSubtotal(BigDecimal subtotal) {
		this.subtotal = subtotal;
	}

	public BigDecimal getTotal() {
		return total;
	}

	public void setTotal(BigDecimal total) {
		this.total = total;
	}
	
}
