/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.model.invoicingfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.invoice.dao.InvoiceDao;
import gz.cyberbrain.cyberhotel.model.invoice.to.InvoiceTo;
import gz.cyberbrain.cyberhotel.model.owe.dao.OweDao;
import gz.cyberbrain.cyberhotel.model.owe.to.OweTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;
import java.util.Iterator;

public class DeleteAnInvoiceAction {

	private InvoiceDao invoiceDao;
	private OweDao oweDao;
	private InvoiceTo invoiceTo;

	public DeleteAnInvoiceAction(InvoiceDao invoiceDao, OweDao oweDao, InvoiceTo invoiceTo) {

		this.invoiceDao = invoiceDao;
		this.oweDao = oweDao;
		this.invoiceTo = invoiceTo;

	}

	public InvoiceTo execute() throws PayedInvoiceException, InstanceNotFoundException, InternalErrorException {

		//Invoice can't have associated payments
		
		if (invoiceDao.payedInvoice(invoiceTo.getInvoiceNumber(), invoiceTo.getInvoiceSerial())) 
			throw new PayedInvoiceException(invoiceTo.getInvoiceNumber(), invoiceTo.getInvoiceSerial());
		
		OweTo owe;
		
		//Deassociate owes from invoice
		Collection oldOwes = invoiceDao.findInvoiceOwes(invoiceTo.getInvoiceNumber(), invoiceTo.getInvoiceSerial());
		Iterator iter = oldOwes.iterator();

		for (int i=0; iter.hasNext();i++) {

			owe = (OweTo) iter.next();
			owe.setInvoiceNumber(null);
			owe.setInvoiceSerial(null);
			owe.setStatus("Pendente");
			oweDao.update(owe);

		}

		//Delete the invoice		
		invoiceDao.remove(invoiceTo);
		return invoiceTo;

	}

	
}
