/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions;

import gz.cyberbrain.cyberhotel.model.util.exceptions.ModelException;

public class PriceNotFoundException extends ModelException {
	
	private static final long serialVersionUID = 1L;
	private Long priceId;
	private String board;
	private String priceType;
	private Long season;

	public PriceNotFoundException(Long priceId, String board, String priceType, Long season){

		super("Price (" + priceId + ", " + board + ", " + priceType + ", " + season + ") is not in database.");

		this.priceId = priceId;
		this.board = board;
		this.priceType = priceType;
		this.season = season;

	}

	public Long getPriceId() {
		return priceId;
	}
	
	public String getBoard() {
		return board;
	}
	
	public String getPriceType() {
		return priceType;
	}
	
	public Long getSeason() {
		return season;
	}
	
}
