/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions;

import gz.cyberbrain.cyberhotel.model.util.exceptions.ModelException;

public class UnaceptableInvoiceException extends ModelException {

	private static final long serialVersionUID = -953276916342748821L;
	private Long invoiceNumber;
	private String invoiceSerial;
	
	public UnaceptableInvoiceException (Long invoiceNumber, String invoiceSerial) {
		
		super ("Invoice " + invoiceNumber + "/" + invoiceSerial + " is not in database.");
		this.invoiceNumber = invoiceNumber;
		this.invoiceSerial = invoiceSerial;
	}
	
	public Long getInvoiceNumber() {
		return invoiceNumber;
	}
	
	public String getInvoiceSerial() {
		return invoiceSerial;
	}
	
}
