/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.model.reservationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.client.dao.ClientDao;
import gz.cyberbrain.cyberhotel.model.client.to.AgencyTo;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.ClientPayerException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.AgencyWithReservationsException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.ClientWithInvoicesException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class RemoveAnAgencyAction {

private AgencyTo agencyTo;
private ClientDao agencyDao;
	
	public RemoveAnAgencyAction(AgencyTo agencyTo, ClientDao agencyDao) {
		this.agencyTo = agencyTo;
		this.agencyDao = agencyDao;
	}
	
	public void execute() 
		throws AgencyWithReservationsException, ClientPayerException, 
		ClientWithInvoicesException, InternalErrorException {
		
		if (agencyDao.isPayer(agencyTo.getClientId()))
			throw new ClientPayerException(agencyTo);
		
		if (agencyDao.existInvoices(agencyTo.getClientId()))
			throw new ClientWithInvoicesException(agencyTo);
		
		if (agencyDao.takesPartInReservation(agencyTo.getClientId()))
			throw new AgencyWithReservationsException(agencyTo);
		
		agencyDao.remove(agencyTo);
		
	}

}
