/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.view.swing.invoicing;

import gz.cyberbrain.cyberhotel.controller.ConceptListAdapter;
import gz.cyberbrain.cyberhotel.controller.OweController;
import gz.cyberbrain.cyberhotel.controller.ParticularListAdapter;
import gz.cyberbrain.cyberhotel.controller.RoomListAdapter;
import gz.cyberbrain.cyberhotel.view.swing.start.MainWindow;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.AutofitTableColumns;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.DateRenderer;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.NumberEditor;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.OwesList;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.OwesTableModel;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.TableItem;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.TextItem;
import gz.cyberbrain.cyberhotel.view.swing.util.locale.Locale;

import javax.swing.DefaultCellEditor;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;

import java.awt.Rectangle;

import java.math.BigDecimal;
import java.text.DateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Vector;

import org.jdesktop.swingx.table.DatePickerCellEditor;

public class OwesDialog extends JDialog {

	private static final long serialVersionUID = 1L;

	private OwesList observer = null;
	private JPanel jContentPane = null;
	private JLabel roomLabel = null;
	private JComboBox roomComboBox = null;
	private JLabel particularLabel = null;
	private JComboBox particularComboBox = null;
	private JComboBox conceptComboBox = null;
	private JComboBox statusComboBox = null;
	private JScrollPane owesScrollPane = null;
	private JTable owesTable = null;
	private JButton acceptButton = null;
	private JButton exitButton = null;
	private Object [][]owes = null;

	/**
	 * This is the xxx default constructor
	 */
	public OwesDialog() {
		super(MainWindow.getInstance(), true);
		initialize();
	}

	public OwesList getObserver() {
		return observer;
	}

	public void setObserver(OwesList observer) {
		this.observer = observer;
	}

	public Object[][] getOwes() {
		return owes;
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(851, 677);
		this.setContentPane(getJContentPane());
		this.setTitle(Locale.get("OwesDialog.title"));
		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		//(MainWindow.getInstance()).activateGlassPane();
		/*	this.addWindowListener(new WindowListener() {

			public void windowActivated(WindowEvent arg0) {	}

			public void windowClosed(WindowEvent arg0) {
				//(MainWindow.getInstance()).deactivateGlassPane();	
			}

			public void windowClosing(WindowEvent arg0) {}

			public void windowDeactivated(WindowEvent arg0) {}

			public void windowDeiconified(WindowEvent arg0) {}

			public void windowIconified(WindowEvent arg0) {}

			public void windowOpened(WindowEvent arg0) {}

		});*/
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			particularLabel = new JLabel();
			particularLabel.setBounds(new Rectangle(182, 58, 61, 16));
			particularLabel.setText(Locale.get("OwesDialog.particularLabel"));
			roomLabel = new JLabel();
			roomLabel.setBounds(new Rectangle(17, 58, 62, 16));
			roomLabel.setText(Locale.get("OwesDialog.roomLabel"));
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(roomLabel, null);
			jContentPane.add(getRoomComboBox(), null);
			jContentPane.add(particularLabel, null);
			jContentPane.add(getParticularComboBox(), null);
			jContentPane.add(getOwesScrollPane(), null);
			jContentPane.add(getAcceptButton(), null);
			jContentPane.add(getCancelButton(), null);		
		}
		return jContentPane;
	}

	@SuppressWarnings("unchecked")
	private Vector getRooms() {
		Vector rooms = (new RoomListAdapter()).load();
		rooms.insertElementAt(new TextItem(new String(""),""), 0);
		return rooms;
	}

	/**
	 * This method initializes roomComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	@SuppressWarnings("unchecked")
	private JComboBox getRoomComboBox() {
		if (roomComboBox == null) {						

			roomComboBox = new JComboBox(getRooms());
			roomComboBox.setBounds(new Rectangle(84, 57, 90, 19));
			roomComboBox.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					refreshOwesTable();

				}
			});
		}
		return roomComboBox;
	}

	@SuppressWarnings("unchecked")
	private Vector getParticulars() {
		Vector particulars = (new ParticularListAdapter()).load();
		particulars.insertElementAt(new TextItem(new Long(0),""), 0);
		return particulars;
	}

	/**
	 * This method initializes particularComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	@SuppressWarnings("unchecked")
	private JComboBox getParticularComboBox() {
		if (particularComboBox == null) {			

			particularComboBox = new JComboBox(getParticulars());
			particularComboBox.setBounds(new Rectangle(252, 57, 259, 19));
			particularComboBox.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					refreshOwesTable();

				}
			});
		}
		return particularComboBox;
	}

	private JComboBox getConceptComboBox() {
		if (conceptComboBox == null) {
			Vector concepts = (new ConceptListAdapter()).load();
			conceptComboBox = new JComboBox(concepts);
		}
		return conceptComboBox;		
	}

	private JComboBox getStatusComboBox() {
		if (statusComboBox == null) {
			Vector <TextItem> status = new Vector<TextItem>();
			status.add(new TextItem("Pendente", Locale.get("OwesDialog.statusComboBox.outstanding")));
			status.add(new TextItem("Facturado", Locale.get("OwesDialog.statusComboBox.billed")));
			statusComboBox = new JComboBox(status);
			statusComboBox.setSelectedIndex(0);
		}		
		return statusComboBox;
	}

	/**
	 * This method initializes owesScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getOwesScrollPane() {
		if (owesScrollPane == null) {
			owesScrollPane = new JScrollPane();
			owesScrollPane.setBounds(new Rectangle(17, 88, 807, 517));
			owesScrollPane.setViewportView(getOwesTable());
		}
		return owesScrollPane;
	}

	private Object [][] loadData() {

		Object [][] data = null;

		Vector rows = new Vector();

		if (getRoomComboBox().getSelectedIndex() != 0 && getParticularComboBox().getSelectedIndex() != 0) {
			rows = OweController.owesByRoomAndParticular((String) ((TextItem) getRoomComboBox().getSelectedItem()).getId(),
					(Long) ((TextItem) getParticularComboBox().getSelectedItem()).getId());
		} else if (getRoomComboBox().getSelectedIndex() != 0) {
			rows = OweController.owesByRoom((String) ((TextItem) getRoomComboBox().getSelectedItem()).getId());
		} else if (getParticularComboBox().getSelectedIndex() != 0){
			rows = OweController.owesByParticular((Long) ((TextItem) getParticularComboBox().getSelectedItem()).getId());
		}

		data = new Object[rows.size()][9];				

		for (int i = 0; i<rows.size(); i++) {
			TableItem item = (TableItem) rows.elementAt(i);
			data[i][0] = (Date) ((Calendar) item.getColumn(0)).getTime();
			data[i][1] = (TextItem) item.getColumn(1);
			data[i][2] = (TextItem) item.getColumn(2);
			data[i][3] = (TextItem) item.getColumn(3);
			data[i][4] = (BigDecimal) item.getColumn(4);
			data[i][5] = (BigDecimal) item.getColumn(5);
			data[i][6] = (BigDecimal) item.getColumn(6);
			if (((String) item.getColumn(7)).equals("Pendente")) data[i][7] = new TextItem("Pendente", Locale.get("OwesDialog.statusComboBox.outstanding"));
			if (((String) item.getColumn(7)).equals("Facturado")) data[i][7] = new TextItem("Facturado", Locale.get("OwesDialog.statusComboBox.billed"));
			data[i][8] = (Long) ((Long) item.getId()[0]).longValue();			
		}

		return data;

	}

	private String[] loadTitles() {

		String [] titles = {
				Locale.get("OwesDialog.owesTable.firstColumn.title"),
				Locale.get("OwesDialog.owesTable.secondColumn.title"),
				Locale.get("OwesDialog.owesTable.thirdColumn.title"),
				Locale.get("OwesDialog.owesTable.fourthColumn.title"),
				Locale.get("OwesDialog.owesTable.fifthColumn.title"),
				Locale.get("OwesDialog.owesTable.sixthColumn.title"),
				Locale.get("OwesDialog.owesTable.seventhColumn.title"),
				Locale.get("OwesDialog.owesTable.eighthColumn.title")
		};

		return titles;
	}


	/**
	 * This method initializes owesTable	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getOwesTable() {
		if (owesTable == null) {
			owesTable = new JTable() {

				private static final long serialVersionUID = 1L;

				public boolean isCellEditable(int row, int col) {
					return false;
				}								

			};

			owesTable.setModel(new OwesTableModel(loadData(), loadTitles()));
			if (owesTable.getRowCount() > 0 ) owesTable.setRowSelectionInterval(0, 0);
			owesTable.getColumnModel().getColumn(0).setCellEditor(new DatePickerCellEditor(DateFormat.getDateInstance(DateFormat.SHORT)));
			owesTable.getColumnModel().getColumn(0).setCellRenderer(new DateRenderer());			
			owesTable.getColumnModel().getColumn(1).setCellEditor(new DefaultCellEditor(new JComboBox(getRooms())));
			owesTable.getColumnModel().getColumn(2).setCellEditor(new DefaultCellEditor(new JComboBox(getParticulars())));			
			owesTable.getColumnModel().getColumn(3).setCellEditor(new DefaultCellEditor(getConceptComboBox()));
			owesTable.getColumnModel().getColumn(4).setCellEditor(new NumberEditor());
			owesTable.getColumnModel().getColumn(5).setCellEditor(new NumberEditor());
			owesTable.getColumnModel().getColumn(6).setCellEditor(new NumberEditor());
			owesTable.getColumnModel().getColumn(7).setCellEditor(new DefaultCellEditor(getStatusComboBox()));

			owesTable.getModel().addTableModelListener(new javax.swing.event.TableModelListener() {

				public void tableChanged(javax.swing.event.TableModelEvent e) {}

			});

			AutofitTableColumns.autoResizeTable(owesTable, true);

		}
		return owesTable;
	}

	private void refreshOwesTable() {
		owesTable.setModel(new OwesTableModel(loadData(), loadTitles()));
		if (owesTable.getRowCount() > 0 ) owesTable.setRowSelectionInterval(0, 0);
		owesTable.getColumnModel().getColumn(0).setCellEditor(new DatePickerCellEditor(DateFormat.getDateInstance(DateFormat.SHORT)));
		owesTable.getColumnModel().getColumn(0).setCellRenderer(new DateRenderer());			
		owesTable.getColumnModel().getColumn(1).setCellEditor(new DefaultCellEditor(new JComboBox(getRooms())));
		owesTable.getColumnModel().getColumn(2).setCellEditor(new DefaultCellEditor(new JComboBox(getParticulars())));			
		owesTable.getColumnModel().getColumn(3).setCellEditor(new DefaultCellEditor(getConceptComboBox()));
		owesTable.getColumnModel().getColumn(4).setCellEditor(new NumberEditor());
		owesTable.getColumnModel().getColumn(5).setCellEditor(new NumberEditor());
		owesTable.getColumnModel().getColumn(6).setCellEditor(new NumberEditor());
		owesTable.getColumnModel().getColumn(7).setCellEditor(new DefaultCellEditor(getStatusComboBox()));

		owesTable.getModel().addTableModelListener(new javax.swing.event.TableModelListener() {

			public void tableChanged(javax.swing.event.TableModelEvent e) {}

		});

		AutofitTableColumns.autoResizeTable(owesTable, true);

		owesTable.repaint();

	}

	/**
	 * This method initializes acceptButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getAcceptButton() {
		if (acceptButton == null) {
			acceptButton = new JButton();
			acceptButton.setBounds(new Rectangle(656, 613, 77, 17));
			acceptButton.setText(Locale.get("OwesDialog.acceptButton"));
			acceptButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					int []indexes = getOwesTable().getSelectedRows();
					owes = new Object[indexes.length][getOwesTable().getColumnCount() + 1];

					for (int i=0; i < indexes.length; i++)	{			
						for (int j=0; j < getOwesTable().getColumnCount(); j++)  
							owes[i][j] = getOwesTable().getValueAt(indexes[i], j);
						
						owes[i][8] = (Long) ((OwesTableModel) getOwesTable().getModel()).getCustomValueAt(indexes[i], 8);
				
					}
					
					getObserver().setOwesList(owes);

				}

			});

		}
		return acceptButton;
	}

	/**
	 * This method initializes exitButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getCancelButton() {
		if (exitButton == null) {
			exitButton = new JButton();
			exitButton.setBounds(new Rectangle(750, 613, 77, 17));
			exitButton.setText(Locale.get("OwesDialog.exitButton"));
			exitButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					dispose();

				}
			});

		}
		return exitButton;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
