/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.view.swing.start;

import gz.cyberbrain.cyberhotel.controller.AgencyListAdapter;
import gz.cyberbrain.cyberhotel.controller.BankListAdapter;
import gz.cyberbrain.cyberhotel.controller.BoardListAdapter;
import gz.cyberbrain.cyberhotel.controller.CardListAdapter;
import gz.cyberbrain.cyberhotel.controller.CheckInCreator;
import gz.cyberbrain.cyberhotel.controller.CheckOutCreator;
import gz.cyberbrain.cyberhotel.controller.CompanyListAdapter;
import gz.cyberbrain.cyberhotel.controller.ConceptListAdapter;
import gz.cyberbrain.cyberhotel.controller.EmployeeListAdapter;
import gz.cyberbrain.cyberhotel.controller.InvoiceCreator;
import gz.cyberbrain.cyberhotel.controller.ParticularListAdapter;
import gz.cyberbrain.cyberhotel.controller.PaymentCreator;
import gz.cyberbrain.cyberhotel.controller.PriceTypeListAdapter;
import gz.cyberbrain.cyberhotel.controller.ReservationCreator;
import gz.cyberbrain.cyberhotel.controller.RoomListAdapter;
import gz.cyberbrain.cyberhotel.controller.RoomTypeListAdapter;
import gz.cyberbrain.cyberhotel.controller.SeasonListAdapter;
import gz.cyberbrain.cyberhotel.view.swing.edit.AddressWindow;
import gz.cyberbrain.cyberhotel.view.swing.edit.BankingWindow;
import gz.cyberbrain.cyberhotel.view.swing.edit.BoardWindow;
import gz.cyberbrain.cyberhotel.view.swing.edit.CalendarWindow;
import gz.cyberbrain.cyberhotel.view.swing.edit.ConceptWindow;
import gz.cyberbrain.cyberhotel.view.swing.edit.EmployeeWindow;
import gz.cyberbrain.cyberhotel.view.swing.edit.ListWindow;
import gz.cyberbrain.cyberhotel.view.swing.edit.PriceTypeWindow;
import gz.cyberbrain.cyberhotel.view.swing.edit.PriceWindow;
import gz.cyberbrain.cyberhotel.view.swing.edit.RoomTypeWindow;
import gz.cyberbrain.cyberhotel.view.swing.edit.RoomWindow;
import gz.cyberbrain.cyberhotel.view.swing.edit.SeasonWindow;
import gz.cyberbrain.cyberhotel.view.swing.invoicing.CashWindow;
import gz.cyberbrain.cyberhotel.view.swing.invoicing.InvoiceWindow;
import gz.cyberbrain.cyberhotel.view.swing.invoicing.PaymentWindow;
import gz.cyberbrain.cyberhotel.view.swing.reception.AgencyWindow;
import gz.cyberbrain.cyberhotel.view.swing.reception.CompanyWindow;
import gz.cyberbrain.cyberhotel.view.swing.reception.GroupCheckInWindow;
import gz.cyberbrain.cyberhotel.view.swing.reception.GroupCheckOutWindow;
import gz.cyberbrain.cyberhotel.view.swing.reception.GroupReservationWindow;
import gz.cyberbrain.cyberhotel.view.swing.reception.IndividualCheckInWindow;
import gz.cyberbrain.cyberhotel.view.swing.reception.IndividualCheckOutWindow;
import gz.cyberbrain.cyberhotel.view.swing.reception.IndividualReservationWindow;
import gz.cyberbrain.cyberhotel.view.swing.reception.OweWindow;
import gz.cyberbrain.cyberhotel.view.swing.reception.ParticularWindow;
import gz.cyberbrain.cyberhotel.view.swing.reception.RoomPlanningWindow;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.CustomCellRenderer;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.InfoPanel;
import gz.cyberbrain.cyberhotel.view.swing.util.locale.Locale;

import java.awt.Color;
import java.awt.Frame;
import java.awt.GraphicsEnvironment;
import java.awt.Rectangle;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;
import java.beans.PropertyVetoException;

import javax.swing.DefaultListCellRenderer;
import javax.swing.JDesktopPane;
import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.KeyStroke;

public class MainWindow extends JFrame {

	private static final long serialVersionUID = 1L;	

	private static MainWindow mainWindow = null;

	private static ListWindow banksList = null;
	private static ListWindow cardsList = null;
	private static ListWindow roomTypesList = null;
	private static ListWindow roomsList = null;
	private static ListWindow boardsList = null;
	private static ListWindow priceTypesList = null;
	private static ListWindow seasonsList = null;
	private static ListWindow conceptsList = null;
	private static ListWindow particularsList = null;
	private static ListWindow agenciesList = null;
	private static ListWindow companiesList = null;
	private static ListWindow employeesList = null;
	
	private JDesktopPane jDesktopPane = null;

	private JMenuBar hotelMenuBar = null;

	private JMenu hotelMenu = null;

	private JMenu editMenu = null;

	private JMenu receptionMenu = null;
	
	private JMenu invoicingMenu = null;

	private JMenuItem exitMenuItem = null;

	private JMenuItem addressMenuItem = null;	 

	private JMenu bankingMenu = null;

	private JMenuItem banksMenuItem = null;

	private JMenuItem cardsMenuItem = null;

	private JMenu roomsMenu = null;

	private JMenuItem roomTypesMenuItem = null;

	private JMenuItem roomsMenuItem = null;

	private JMenu pricesMenu = null;

	private JMenuItem boardsMenuItem = null;

	private JMenuItem priceTypesMenuItem = null;

	private JMenuItem pricesMenuItem = null;

	private JMenuItem seasonsMenuItem = null;

	private JMenuItem conceptsMenuItem = null;

	private JMenuItem calendarMenuItem = null;

	private JMenu clientsMenu = null;

	private JMenuItem particularsMenuItem = null;

	private JMenuItem agenciesMenuItem = null;

	private JMenuItem companiesMenuItem = null;

	private JMenu reservationsMenu = null;

	private JMenuItem singlesMenuItem = null;

	private JMenuItem groupsMenuItem = null;

	private JMenuItem reservationsPlanningMenuItem = null; 

	private JMenu inMenu = null;

	private JMenuItem singlesCheckInMenuItem = null;

	private JMenuItem groupsCheckInMenuItem = null;

	private JMenu outMenu = null;

	private JMenuItem singlesCheckOutMenuItem = null;

	private JMenuItem groupsCheckOutMenuItem = null;

	private JMenuItem owesMenuItem = null;

	private JMenuItem roomPlanningMenuItem = null;
	
	private JMenuItem employeesMenuItem = null;
	
	private JMenuItem invoicesMenuItem = null;
	
	private JMenuItem paymentsMenuItem = null;
	
	private JMenuItem cashMenuItem = null;

	/**
	 * This is the default constructor
	 */
	private MainWindow() {
		super();
		initialize();
	}

	public static MainWindow getInstance() {
		if (mainWindow == null) mainWindow = new MainWindow();
		return mainWindow;
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		GraphicsEnvironment graphicsEnvironment=GraphicsEnvironment.getLocalGraphicsEnvironment();
		Rectangle maximumWindowBounds=graphicsEnvironment.getMaximumWindowBounds();

		this.setLocation(0,0);

		this.setSize(maximumWindowBounds.width, maximumWindowBounds.height);
		this.setMaximizedBounds(maximumWindowBounds);
		this.setState(Frame.NORMAL);

		this.setTitle(Locale.get("MainWindow.title"));		
		this.setContentPane(getJDesktopPane());			
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		this.setJMenuBar(getJJMenuBar());				
	}

	private JDesktopPane getJDesktopPane() {
		if (jDesktopPane == null) {
			jDesktopPane = new JDesktopPane();
			jDesktopPane.setDragMode(JDesktopPane.OUTLINE_DRAG_MODE);
			jDesktopPane.setBackground(Color.LIGHT_GRAY);
		}
		return jDesktopPane;
	}

	/**
	 * This method initializes hotelMenuBar	
	 * 	
	 * @return javax.swing.JMenuBar	
	 */
	private JMenuBar getJJMenuBar() {
		if (hotelMenuBar == null) {
			hotelMenuBar = new JMenuBar();			
			hotelMenuBar.add(getHotelMenu());			
			hotelMenuBar.add(getEditMenu());
			hotelMenuBar.add(getReceptionMenu());
			hotelMenuBar.add(getInvoicingMenu());
		}
		return hotelMenuBar;
	}

	/**
	 * This method initializes hotelMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getHotelMenu() {
		if (hotelMenu == null) {
			hotelMenu = new JMenu();
			hotelMenu.setText(Locale.get("MainWindow.hotelMenu"));
			hotelMenu.setMnemonic(KeyEvent.VK_H);
			hotelMenu.add(getExitMenuItem());
		}
		return hotelMenu;
	}

	/**
	 * This method initializes editMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getEditMenu() {
		if (editMenu == null) {
			editMenu = new JMenu();
			editMenu.setText(Locale.get("MainWindow.editMenu"));
			editMenu.setMnemonic(KeyEvent.VK_E);
			editMenu.add(getAddressMenuItem());			
			editMenu.add(getBankingMenu());
			editMenu.add(getRoomsMenu());			
			editMenu.add(getPricesMenu());						
			editMenu.add(getConceptsMenuItem());
			editMenu.add(getEmloyeesMenuItem());
			editMenu.addSeparator();
			editMenu.add(getCalendarMenuItem());
		}
		return editMenu;
	}

	private JMenuItem getEmloyeesMenuItem() {
		if (employeesMenuItem == null) {
			employeesMenuItem = new JMenuItem();
			employeesMenuItem.setText(Locale.get("MainWindow.employeesMenuItem"));
			employeesMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					if (employeesList == null) {

						InfoPanel ipanel = new InfoPanel();
						InfoPanel ipanel2 = new InfoPanel();

						EmployeeWindow employeeWindow =  EmployeeWindow.getInstance();					

						ipanel2.setBounds(0,0,employeeWindow.getWidth(),50);
						ipanel2.setInfoText(Locale.get("EmployeeWindow.infoText"));
						employeeWindow.setInfoPanel(ipanel2);
						employeeWindow.setTitle(Locale.get("EmployeeWindow.title"));					

						ListWindow listWindow = new ListWindow();
						listWindow.setAdapter(new EmployeeListAdapter());
						listWindow.setCellRenderer(new DefaultListCellRenderer());
						listWindow.loadList();
						listWindow.setChild(employeeWindow);
						employeeWindow.setOwner(listWindow);
						ipanel.setBounds(0,0,listWindow.getWidth(),50);
						ipanel.setInfoText(Locale.get("ListWindow.Employees.infoText"));
						listWindow.setInfoPanel(ipanel);
						listWindow.setTitle(Locale.get("ListWindow.Employees.title"));						
						getContentPane().add(listWindow);
						listWindow.setVisible(true);
						employeesList = listWindow;

					} else {

						employeesList.loadList();					
						showInDesktopPane(employeesList);

					}

				}
			});

		}
		return employeesMenuItem;

	}

	/**
	 * This method initializes receptionMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getReceptionMenu() {
		if (receptionMenu == null) {
			receptionMenu = new JMenu();			
			receptionMenu.setText(Locale.get("MainWindow.receptionMenu"));
			receptionMenu.setMnemonic(KeyEvent.VK_R);
			receptionMenu.add(getClientsMenu());
			receptionMenu.add(getReservationsMenu());
			receptionMenu.add(getInMenu());
			receptionMenu.add(getOutMenu());			
			receptionMenu.add(getOwesMenuItem());
			receptionMenu.addSeparator();
			receptionMenu.add(getRoomPlanningMenuItem());
		}
		return receptionMenu;
	}

	/**
	 * This method initializes invoicingMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getInvoicingMenu() {
		if (invoicingMenu == null) {
			invoicingMenu = new JMenu();			
			invoicingMenu.setText(Locale.get("MainWindow.invoicingMenu"));
			invoicingMenu.setMnemonic(KeyEvent.VK_F);
			invoicingMenu.add(getInvoicesMenuItem());
			invoicingMenu.add(getPaymentsMenuItem());
			invoicingMenu.add(getCashMenuItem());
		}
		return invoicingMenu;
	}

	
	/**
	 * This method initializes exitMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getExitMenuItem() {
		if (exitMenuItem == null) {
			exitMenuItem = new JMenuItem();
			exitMenuItem.setText(Locale.get("MainWindow.exitMenuItem"));
			exitMenuItem.setMnemonic(KeyEvent.VK_S);
			exitMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F4,InputEvent.ALT_MASK));			
			exitMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					MainWindow mainWindow = MainWindow.getInstance();														
					mainWindow.setVisible(false);
					mainWindow.dispose();
					System.exit(0);

				}
			});
		}
		return exitMenuItem;
	}

	/**
	 * This method initializes addressMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getAddressMenuItem() {
		if (addressMenuItem == null) {
			addressMenuItem = new JMenuItem();
			addressMenuItem.setText(Locale.get("MainWindow.addressMenuItem"));
			addressMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					InfoPanel ipanel = new InfoPanel();
					ipanel.setInfoText(Locale.get("AddressWindow.infoText"));

					AddressWindow addressWindow = AddressWindow.getInstance();					
					addressWindow.setTitle(Locale.get("AddressWindow.title"));
					ipanel.setBounds(0,0,addressWindow.getWidth(),50);
					addressWindow.setInfoPanel(ipanel);

					showInDesktopPane(addressWindow);

				}
			});
		}
		return addressMenuItem;
	}

	/**
	 * This method initializes bankingMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */


	private JMenu getBankingMenu() {
		if (bankingMenu == null) {
			bankingMenu = new JMenu();
			bankingMenu.setText(Locale.get("MainWindow.bankingMenu"));
			bankingMenu.add(getBanksMenuItem());
			bankingMenu.add(getCardsMenuItem());
		}
		return bankingMenu;
	}

	private JMenuItem getBanksMenuItem() {
		if (banksMenuItem == null) {
			banksMenuItem = new JMenuItem();
			banksMenuItem.setText(Locale.get("MainWindow.banksMenuItem"));
			banksMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					if (banksList == null) {

						InfoPanel ipanel = new InfoPanel();	
						InfoPanel ipanel2 = new InfoPanel();

						BankingWindow bankingWindow = new BankingWindow();
						bankingWindow.setTitle(Locale.get("BankingWindow.Banks.title"));

						ipanel2.setBounds(0,0,bankingWindow.getWidth(),50);
						ipanel2.setInfoText(Locale.get("BankingWindow.Banks.infoText"));
						bankingWindow.setInfoPanel(ipanel2);
						bankingWindow.setDialogMessage(Locale.get("JOptionPane.BankingWindow.saveButton.bankMessage.ok"));
						bankingWindow.setDialogTitle(Locale.get("JOptionPane.BankingWindow.saveButton.bankTitle.ok"));

						ListWindow listWindow = new ListWindow();
						listWindow.setAdapter(new BankListAdapter());
						listWindow.setCellRenderer(new CustomCellRenderer());
						listWindow.loadList();
						listWindow.setChild(bankingWindow);
						bankingWindow.setOwner(listWindow);
						ipanel.setBounds(0,0,listWindow.getWidth(),50);
						ipanel.setInfoText(Locale.get("ListWindow.Banks.infoText"));
						listWindow.setInfoPanel(ipanel);					
						listWindow.setTitle(Locale.get("ListWindow.Banks.title"));											
						getContentPane().add(listWindow);
						listWindow.setVisible(true);
						banksList = listWindow;						
					} else {						

						banksList.setAdapter(new BankListAdapter());
						banksList.loadList();		
						showInDesktopPane(banksList);

					}

				}
			});

		}
		return banksMenuItem;
	}

	private JMenuItem getCardsMenuItem() {
		if (cardsMenuItem == null) {
			cardsMenuItem = new JMenuItem();
			cardsMenuItem.setText(Locale.get("MainWindow.cardsMenuItem"));
			cardsMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					if (cardsList == null) {

						InfoPanel ipanel = new InfoPanel();					
						InfoPanel ipanel2 = new InfoPanel();

						BankingWindow bankingWindow = new BankingWindow();
						bankingWindow.setTitle(Locale.get("BankingWindow.Cards.title"));

						ipanel2.setBounds(0,0,bankingWindow.getWidth(),50);
						ipanel2.setInfoText(Locale.get("BankingWindow.Cards.infoText"));
						bankingWindow.setInfoPanel(ipanel2);						
						bankingWindow.setDialogMessage(Locale.get("JOptionPane.BankingWindow.saveButton.cardMessage"));
						bankingWindow.setDialogTitle(Locale.get("JOptionPane.BankingWindow.saveButton.cardTitle"));

						ListWindow listWindow = new ListWindow();
						listWindow.setAdapter(new CardListAdapter());
						listWindow.setCellRenderer(new CustomCellRenderer());
						listWindow.loadList();						
						listWindow.setChild(bankingWindow);
						bankingWindow.setOwner(listWindow);
						ipanel.setBounds(0,0,listWindow.getWidth(),50);
						ipanel.setInfoText(Locale.get("ListWindow.Cards.infoText"));					
						listWindow.setInfoPanel(ipanel);
						listWindow.setTitle(Locale.get("ListWindow.Cards.title"));						
						getContentPane().add(listWindow);
						listWindow.setVisible(true);
						cardsList = listWindow;
					} else {					
						cardsList.setAdapter(new CardListAdapter());
						cardsList.loadList();
						showInDesktopPane(cardsList);
					}

				}
			});

		}
		return cardsMenuItem;
	}

	/**
	 * This method initializes roomsMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getRoomsMenu() {
		if (roomsMenu == null) {
			roomsMenu = new JMenu();
			roomsMenu.setText(Locale.get("MainWindow.roomsMenu"));
			roomsMenu.add(getRoomTypesMenuItem());
			roomsMenu.add(getRoomsMenuItem());
		}
		return roomsMenu;
	}

	private JMenuItem getRoomTypesMenuItem() {
		if (roomTypesMenuItem == null) {
			roomTypesMenuItem = new JMenuItem();
			roomTypesMenuItem.setText(Locale.get("MainWindow.roomTypesMenuItem"));
			roomTypesMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					if (roomTypesList == null) {

						InfoPanel ipanel = new InfoPanel();
						InfoPanel ipanel2 = new InfoPanel();

						RoomTypeWindow roomTypeWindow = RoomTypeWindow.getInstance(); 

						ipanel2.setBounds(0,0,roomTypeWindow.getWidth(),50);
						ipanel2.setInfoText(Locale.get("RoomTypeWindow.infoText"));
						roomTypeWindow.setInfoPanel(ipanel2);
						roomTypeWindow.setTitle(Locale.get("RoomTypeWindow.title"));	
						roomTypeWindow.setDialogMessage(Locale.get("JOptionPane.RoomTypeWindow.saveButton.message"));
						roomTypeWindow.setDialogTitle(Locale.get("JOptionPane.RoomTypeWindow.saveButton.title"));

						ListWindow listWindow = new ListWindow();
						listWindow.setAdapter(new RoomTypeListAdapter());
						listWindow.setCellRenderer(new DefaultListCellRenderer());
						listWindow.loadList();						
						listWindow.setChild(roomTypeWindow);
						roomTypeWindow.setOwner(listWindow);
						ipanel.setBounds(0,0,listWindow.getWidth(),50);
						ipanel.setInfoText(Locale.get("ListWindow.RoomTypes.infoText"));
						listWindow.setInfoPanel(ipanel);
						listWindow.setTitle(Locale.get("ListWindow.RoomTypes.title"));						
						getContentPane().add(listWindow);
						listWindow.setVisible(true);
						roomTypesList = listWindow;

					} else {

						roomTypesList.loadList();						
						showInDesktopPane(roomTypesList);

					}

				}
			});
		}
		return roomTypesMenuItem;
	}

	private JMenuItem getRoomsMenuItem() {
		if (roomsMenuItem == null) {
			roomsMenuItem = new JMenuItem();
			roomsMenuItem.setText(Locale.get("MainWindow.roomsMenuItem"));
			roomsMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					if (roomsList == null) {

						InfoPanel ipanel = new InfoPanel();
						InfoPanel ipanel2 = new InfoPanel();

						RoomWindow roomWindow = RoomWindow.getInstance();

						ipanel2.setBounds(0,0,roomWindow.getWidth(),50);
						ipanel2.setInfoText(Locale.get("RoomWindow.infoText"));
						roomWindow.setInfoPanel(ipanel2);
						roomWindow.setTitle(Locale.get("RoomWindow.title"));
						roomWindow.setDialogMessage(Locale.get("JOptionPane.RoomWindow.saveButton.message"));
						roomWindow.setDialogTitle(Locale.get("JOptionPane.RoomWindow.saveButton.title"));


						ListWindow listWindow = new ListWindow();
						listWindow.setAdapter(new RoomListAdapter());
						listWindow.setCellRenderer(new DefaultListCellRenderer());
						listWindow.loadList();						
						listWindow.setChild(roomWindow);
						roomWindow.setOwner(listWindow);
						ipanel.setBounds(0,0,listWindow.getWidth(),50);
						ipanel.setInfoText(Locale.get("ListWindow.Rooms.infoText"));
						listWindow.setInfoPanel(ipanel);
						listWindow.setTitle(Locale.get("ListWindow.Rooms.title"));
						getContentPane().add(listWindow);
						listWindow.setVisible(true);
						roomsList = listWindow;		

					} else {

						roomsList.loadList();						
						showInDesktopPane(roomsList);

					}

				}
			});

		}
		return roomsMenuItem;
	}

	/**
	 * This method initializes pricesMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getPricesMenu() {
		if (pricesMenu == null) {
			pricesMenu = new JMenu();
			pricesMenu.setText(Locale.get("MainWindow.pricesMenu"));
			pricesMenu.add(getBoardsMenuItem());
			pricesMenu.add(getPriceTypesMenuItem());
			pricesMenu.add(getSeasonsMenuItem());
			pricesMenu.addSeparator();
			pricesMenu.add(getPricesMenuItem());
		}
		return pricesMenu;
	}

	private JMenuItem getBoardsMenuItem() {
		if (boardsMenuItem == null) {
			boardsMenuItem = new JMenuItem();
			boardsMenuItem.setText(Locale.get("MainWindow.boardsMenuItem"));
			boardsMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					if (boardsList == null) {

						InfoPanel ipanel = new InfoPanel();
						InfoPanel ipanel2 = new InfoPanel();

						BoardWindow boardWindow =  BoardWindow.getInstance();					

						ipanel2.setBounds(0,0,boardWindow.getWidth(),50);
						ipanel2.setInfoText(Locale.get("BoardWindow.infoText"));
						boardWindow.setInfoPanel(ipanel2);
						boardWindow.setTitle(Locale.get("BoardWindow.title"));
						boardWindow.setDialogMessage(Locale.get("JOptionPane.BoardWindow.saveButton.message"));
						boardWindow.setDialogTitle(Locale.get("JOptionPane.BoardWindow.saveButton.title"));

						ListWindow listWindow = new ListWindow();
						listWindow.setAdapter(new BoardListAdapter());
						listWindow.setCellRenderer(new DefaultListCellRenderer());
						listWindow.loadList();						
						listWindow.setChild(boardWindow);
						boardWindow.setOwner(listWindow);
						ipanel.setBounds(0,0,listWindow.getWidth(),50);
						ipanel.setInfoText(Locale.get("ListWindow.Boards.infoText"));
						listWindow.setInfoPanel(ipanel);
						listWindow.setTitle(Locale.get("ListWindow.Boards.title"));
						getContentPane().add(listWindow);
						listWindow.setVisible(true);
						boardsList = listWindow;											

					} else {

						boardsList.loadList();								
						showInDesktopPane(boardsList);

					}
				}
			});
		}
		return boardsMenuItem;
	}

	private JMenuItem getPriceTypesMenuItem() {
		if (priceTypesMenuItem == null) {
			priceTypesMenuItem = new JMenuItem();
			priceTypesMenuItem.setText(Locale.get("MainWindow.priceTypesMenuItem"));
			priceTypesMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					if (priceTypesList == null) {

						InfoPanel ipanel = new InfoPanel();
						InfoPanel ipanel2 = new InfoPanel();

						PriceTypeWindow priceTypeWindow =  PriceTypeWindow.getInstance();					

						ipanel2.setBounds(0,0,priceTypeWindow.getWidth(),50);
						ipanel2.setInfoText(Locale.get("PriceTypeWindow.infoText"));
						priceTypeWindow.setInfoPanel(ipanel2);
						priceTypeWindow.setTitle(Locale.get("PriceTypeWindow.title"));
						priceTypeWindow.setDialogMessage(Locale.get("JOptionPane.PriceTypeWindow.saveButton.message"));
						priceTypeWindow.setDialogTitle(Locale.get("JOptionPane.PriceTypeWindow.saveButton.title"));


						ListWindow listWindow = new ListWindow();
						listWindow.setAdapter(new PriceTypeListAdapter());
						listWindow.setCellRenderer(new DefaultListCellRenderer());
						listWindow.loadList();
						listWindow.setChild(priceTypeWindow);
						priceTypeWindow.setOwner(listWindow);
						ipanel.setBounds(0,0,listWindow.getWidth(),50);
						ipanel.setInfoText(Locale.get("ListWindow.PriceTypes.infoText"));
						listWindow.setInfoPanel(ipanel);
						listWindow.setTitle(Locale.get("ListWindow.PriceTypes.title"));
						getContentPane().add(listWindow);
						listWindow.setVisible(true);
						priceTypesList = listWindow;								

					} else {

						priceTypesList.loadList();					
						showInDesktopPane(priceTypesList);

					}

				}
			});
		}
		return priceTypesMenuItem;
	}

	private JMenuItem getPricesMenuItem() {
		if (pricesMenuItem == null) {
			pricesMenuItem = new JMenuItem();
			pricesMenuItem.setText(Locale.get("MainWindow.pricesMenuItem"));
			pricesMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					InfoPanel ipanel = new InfoPanel();

					PriceWindow priceWindow =  PriceWindow.getInstance();					

					ipanel.setBounds(0,0,priceWindow.getWidth(),50);
					ipanel.setInfoText(Locale.get("PriceWindow.infoText"));
					priceWindow.setInfoPanel(ipanel);
					priceWindow.setTitle(Locale.get("PriceWindow.title"));
					priceWindow.setDialogMessage(Locale.get("JOptionPane.PriceWindow.delButton.message"));
					priceWindow.setDialogTitle(Locale.get("JOptionPane.PriceWindow.delButton.title"));

					showInDesktopPane(priceWindow);	

				}
			});

		}
		return pricesMenuItem;
	}

	private JMenuItem getSeasonsMenuItem() {
		if (seasonsMenuItem == null) {
			seasonsMenuItem = new JMenuItem();
			seasonsMenuItem.setText(Locale.get("MainWindow.seasonsMenuItem"));
			seasonsMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					if (seasonsList == null) {

						InfoPanel ipanel = new InfoPanel();
						InfoPanel ipanel2 = new InfoPanel();

						SeasonWindow seasonWindow =  SeasonWindow.getInstance();					

						ipanel2.setBounds(0,0,seasonWindow.getWidth(),50);
						ipanel2.setInfoText(Locale.get("SeasonWindow.infoText"));
						seasonWindow.setInfoPanel(ipanel2);
						seasonWindow.setTitle(Locale.get("SeasonWindow.title"));
						seasonWindow.setDialogMessage(Locale.get("JOptionPane.SeasonWindow.saveButton.message"));
						seasonWindow.setDialogTitle(Locale.get("JOptionPane.SeasonWindow.saveButton.title"));

						ListWindow listWindow = new ListWindow();
						listWindow.setAdapter(new SeasonListAdapter());
						listWindow.setCellRenderer(new DefaultListCellRenderer());
						listWindow.loadList();
						listWindow.setChild(seasonWindow);
						seasonWindow.setOwner(listWindow);
						ipanel.setBounds(0,0,listWindow.getWidth(),50);
						ipanel.setInfoText(Locale.get("ListWindow.Seasons.infoText"));
						listWindow.setInfoPanel(ipanel);
						listWindow.setTitle(Locale.get("ListWindow.Seasons.title"));
						listWindow.setVisible(true);
						getContentPane().add(listWindow);
						listWindow.setVisible(true);
						seasonsList = listWindow;

					} else {

						seasonsList.loadList();					
						showInDesktopPane(seasonsList);

					}

				}
			});

		}
		return seasonsMenuItem;
	}	 

	/**
	 * This method initializes conceptsMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getConceptsMenuItem() {
		if (conceptsMenuItem == null) {
			conceptsMenuItem = new JMenuItem();
			conceptsMenuItem.setText(Locale.get("MainWindow.conceptsMenuItem"));
			conceptsMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					if (conceptsList == null) {

						InfoPanel ipanel = new InfoPanel();
						InfoPanel ipanel2 = new InfoPanel();

						ConceptWindow conceptWindow =  ConceptWindow.getInstance();					

						ipanel2.setBounds(0,0,conceptWindow.getWidth(),50);
						ipanel2.setInfoText(Locale.get("ConceptWindow.infoText"));
						conceptWindow.setInfoPanel(ipanel2);
						conceptWindow.setTitle(Locale.get("ConceptWindow.title"));					

						ListWindow listWindow = new ListWindow();
						listWindow.setAdapter(new ConceptListAdapter());
						listWindow.setCellRenderer(new DefaultListCellRenderer());
						listWindow.loadList();
						listWindow.setChild(conceptWindow);
						conceptWindow.setOwner(listWindow);
						ipanel.setBounds(0,0,listWindow.getWidth(),50);
						ipanel.setInfoText(Locale.get("ListWindow.Concepts.infoText"));
						listWindow.setInfoPanel(ipanel);
						listWindow.setTitle(Locale.get("ListWindow.Concepts.title"));						
						getContentPane().add(listWindow);
						listWindow.setVisible(true);
						conceptsList = listWindow;

					} else {

						conceptsList.loadList();					
						showInDesktopPane(conceptsList);

					}

				}
			});

		}
		return conceptsMenuItem;
	}

	public JMenuItem getCalendarMenuItem() {
		if (calendarMenuItem == null) {
			calendarMenuItem = new JMenuItem();
			calendarMenuItem.setText(Locale.get("MainWindow.calendarMenuItem"));
			calendarMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					InfoPanel ipanel = new InfoPanel();

					CalendarWindow calendarWindow =  CalendarWindow.getInstance();					

					calendarWindow.setInfoPanel(ipanel);
					calendarWindow.setTitle(Locale.get("CalendarWindow.title"));						
					ipanel.setBounds(0,0,calendarWindow.getWidth(),50);						

					showInDesktopPane(calendarWindow);
					
				}
			});

		}
		return calendarMenuItem;
	}

	/**
	 * This method initializes clientsMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getClientsMenu() {
		if (clientsMenu == null) {
			clientsMenu = new JMenu();
			clientsMenu.setText(Locale.get("MainWindow.clientsMenu"));
			clientsMenu.add(getParticularsMenuItem());
			clientsMenu.add(getAgenciesMenuItem());
			clientsMenu.add(getCompaniesMenuItem());
		}
		return clientsMenu;
	}

	private JMenuItem getParticularsMenuItem() {
		if (particularsMenuItem == null) {
			particularsMenuItem = new JMenuItem();
			particularsMenuItem.setText(Locale.get("MainWindow.particularsMenuItem"));
			particularsMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					if (particularsList == null) {

						InfoPanel ipanel = new InfoPanel();
						InfoPanel ipanel2 = new InfoPanel();

						ParticularWindow particularWindow = ParticularWindow.getInstance();

						ipanel2.setBounds(0,0,particularWindow.getWidth(),50);
						ipanel2.setInfoText(Locale.get("ParticularWindow.infoText"));
						particularWindow.setInfoPanel(ipanel2);
						particularWindow.setTitle(Locale.get("ParticularWindow.title"));						

						ListWindow listWindow = new ListWindow();
						listWindow.setChild(particularWindow);
						listWindow.setAdapter(new ParticularListAdapter());
						listWindow.setCellRenderer(new DefaultListCellRenderer());
						listWindow.loadList();
						particularWindow.setOwner(listWindow);
						ipanel.setBounds(0,0,listWindow.getWidth(),50);
						ipanel.setInfoText(Locale.get("ListWindow.Particulars.infoText"));
						listWindow.setInfoPanel(ipanel);
						listWindow.setTitle(Locale.get("ListWindow.Particulars.title"));
						listWindow.setVisible(true);	
						getContentPane().add(listWindow);						
						particularsList = listWindow;						

					} else {

						particularsList.loadList();					
						showInDesktopPane(particularsList);

					}

				}

			});

		}
		return particularsMenuItem;
	}

	private JMenuItem getAgenciesMenuItem() {
		if (agenciesMenuItem == null) {
			agenciesMenuItem = new JMenuItem();
			agenciesMenuItem.setText(Locale.get("MainWindow.agenciesMenuItem"));
			agenciesMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					if (agenciesList == null) {

						InfoPanel ipanel = new InfoPanel();
						InfoPanel ipanel2 = new InfoPanel();

						AgencyWindow agencyWindow = AgencyWindow.getInstance();

						ipanel2.setBounds(0,0,agencyWindow.getWidth(),50);
						ipanel2.setInfoText(Locale.get("AgencyWindow.infoText"));
						agencyWindow.setInfoPanel(ipanel2);
						agencyWindow.setTitle(Locale.get("AgencyWindow.title"));

						ListWindow listWindow = new ListWindow();
						listWindow.setChild(agencyWindow);
						listWindow.setAdapter(new AgencyListAdapter());
						listWindow.setCellRenderer(new DefaultListCellRenderer());
						listWindow.loadList();
						agencyWindow.setOwner(listWindow);
						ipanel.setBounds(0,0,listWindow.getWidth(),50);
						ipanel.setInfoText(Locale.get("ListWindow.Agencies.infoText"));
						listWindow.setInfoPanel(ipanel);
						listWindow.setTitle(Locale.get("ListWindow.Agencies.title"));
						listWindow.setVisible(true);
						getContentPane().add(listWindow);						
						agenciesList = listWindow;

					} else {

						agenciesList.loadList();					
						showInDesktopPane(agenciesList);

					}

				}
			});

		}
		return agenciesMenuItem;
	}

	private JMenuItem getCompaniesMenuItem() {
		if (companiesMenuItem == null) {
			companiesMenuItem = new JMenuItem();
			companiesMenuItem.setText(Locale.get("MainWindow.companiesMenuItem"));
			companiesMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					if (companiesList == null) {

						InfoPanel ipanel = new InfoPanel();
						InfoPanel ipanel2 = new InfoPanel();

						CompanyWindow companyWindow = CompanyWindow.getInstance();

						ipanel2.setBounds(0,0,companyWindow.getWidth(),50);
						ipanel2.setInfoText(Locale.get("CompanyWindow.infoText"));
						companyWindow.setInfoPanel(ipanel2);
						companyWindow.setTitle(Locale.get("CompanyWindow.title"));

						ListWindow listWindow = new ListWindow();
						listWindow.setChild(companyWindow);
						listWindow.setAdapter(new CompanyListAdapter());
						listWindow.setCellRenderer(new DefaultListCellRenderer());
						listWindow.loadList();
						companyWindow.setOwner(listWindow);
						ipanel.setBounds(0,0,listWindow.getWidth(),50);
						ipanel.setInfoText(Locale.get("ListWindow.Companies.infoText"));
						listWindow.setInfoPanel(ipanel);
						listWindow.setTitle(Locale.get("ListWindow.Companies.title"));
						listWindow.setVisible(true);	
						getContentPane().add(listWindow);						
						companiesList = listWindow;

					} else {

						companiesList.loadList();					
						showInDesktopPane(companiesList);

					}

				}
			});

		}
		return companiesMenuItem;
	}

	/**
	 * This method initializes reservationsMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getReservationsMenu() {
		if (reservationsMenu == null) {
			reservationsMenu = new JMenu();
			reservationsMenu.setText(Locale.get("MainWindow.reservationsMenu"));
			reservationsMenu.add(getSinglesMenuItem());
			reservationsMenu.add(getGroupsMenuItem());
			reservationsMenu.addSeparator();
			reservationsMenu.add(getReservationsPlanningMenuItem());
		}
		return reservationsMenu;
	}

	private JMenuItem getSinglesMenuItem() {
		if (singlesMenuItem == null) {
			singlesMenuItem = new JMenuItem();
			singlesMenuItem.setText(Locale.get("MainWindow.singlesMenuItem"));
			singlesMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

						InfoPanel ipanel = new InfoPanel();

						IndividualReservationWindow individualReservationWindow =  IndividualReservationWindow.getInstance();					

						ipanel.setBounds(0,0,individualReservationWindow.getWidth(),50);
						ipanel.setInfoText(Locale.get("IndividualReservationWindow.infoText"));
						individualReservationWindow.setInfoPanel(ipanel);
						individualReservationWindow.setTitle(Locale.get("IndividualReservationWindow.title"));
						individualReservationWindow.setDialogMessage(Locale.get("JOptionPane.IndividualReservationWindow.saveButton.message"));
						individualReservationWindow.setDialogTitle(Locale.get("JOptionPane.IndividualReservationWindow.saveButton.title"));
						individualReservationWindow.setAdapter(new ReservationCreator());

						showInDesktopPane(individualReservationWindow);

				}
			});

		}
		return singlesMenuItem;
	}

	private JMenuItem getGroupsMenuItem() {
		if (groupsMenuItem == null) {
			groupsMenuItem = new JMenuItem();
			groupsMenuItem.setText(Locale.get("MainWindow.groupsMenuItem"));
			groupsMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

		

						InfoPanel ipanel = new InfoPanel();

						GroupReservationWindow groupReservationWindow =  GroupReservationWindow.getInstance();					

						ipanel.setBounds(0,0,groupReservationWindow.getWidth(),50);
						ipanel.setInfoText(Locale.get("GroupReservationWindow.infoText"));
						groupReservationWindow.setInfoPanel(ipanel);
						groupReservationWindow.setTitle(Locale.get("GroupReservationWindow.title"));
						groupReservationWindow.setDialogMessage(Locale.get("JOptionPane.GroupReservationWindow.saveButton.message"));
						groupReservationWindow.setDialogTitle(Locale.get("JOptionPane.GroupReservationWindow.saveButton.title"));
						groupReservationWindow.setAdapter(new ReservationCreator());
						
						showInDesktopPane(groupReservationWindow);

				}
			});

		}
		return groupsMenuItem;
	}

	private JMenuItem getReservationsPlanningMenuItem() {
		if (reservationsPlanningMenuItem == null) {
			reservationsPlanningMenuItem = new JMenuItem();
			reservationsPlanningMenuItem.setText(Locale.get("MainWindow.reservationsPlanningMenuItem"));			
		}
		return reservationsPlanningMenuItem;
	}

	/**
	 * This method initializes inMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getInMenu() {
		if (inMenu == null) {
			inMenu = new JMenu();
			inMenu.setText(Locale.get("MainWindow.inMenu"));
			inMenu.add(getSinglesCheckInMenuItem());
			inMenu.add(getGroupsCheckInMenuItem());
		}
		return inMenu;
	}

	private JMenuItem getSinglesCheckInMenuItem() {
		if (singlesCheckInMenuItem == null) {
			singlesCheckInMenuItem = new JMenuItem();
			singlesCheckInMenuItem.setText(Locale.get("MainWindow.singlesCheckInMenuItem"));
			singlesCheckInMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

						InfoPanel ipanel = new InfoPanel();

						IndividualCheckInWindow individualCheckInWindow =  IndividualCheckInWindow.getInstance();					

						ipanel.setBounds(0,0,individualCheckInWindow.getWidth(),50);
						ipanel.setInfoText(Locale.get("IndividualCheckInWindow.infoText"));
						individualCheckInWindow.setInfoPanel(ipanel);
						individualCheckInWindow.setTitle(Locale.get("IndividualCheckInWindow.title"));
						individualCheckInWindow.setAdapter(new CheckInCreator());

						showInDesktopPane(individualCheckInWindow);

				}
			});

		}
		return singlesCheckInMenuItem;
	}

	private JMenuItem getGroupsCheckInMenuItem() {
		if (groupsCheckInMenuItem == null) {
			groupsCheckInMenuItem = new JMenuItem();
			groupsCheckInMenuItem.setText(Locale.get("MainWindow.groupsCheckInMenuItem"));
			groupsCheckInMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

						InfoPanel ipanel = new InfoPanel();

						GroupCheckInWindow groupCheckInWindow =  GroupCheckInWindow.getInstance();					

						ipanel.setBounds(0,0,groupCheckInWindow.getWidth(),50);
						ipanel.setInfoText(Locale.get("GroupCheckInWindow.infoText"));
						groupCheckInWindow.setInfoPanel(ipanel);
						groupCheckInWindow.setTitle(Locale.get("GroupCheckInWindow.title"));

						groupCheckInWindow.setAdapter(new CheckInCreator());

						showInDesktopPane(groupCheckInWindow);

				}
			});

		}
		return groupsCheckInMenuItem;
	}

	/**
	 * This method initializes outMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getOutMenu() {
		if (outMenu == null) {
			outMenu = new JMenu();
			outMenu.setText(Locale.get("MainWindow.outMenu"));
			outMenu.add(getSinglesCheckOutMenuItem());
			outMenu.add(getGroupsCheckOutMenuItem());
		}
		return outMenu;
	}

	private JMenuItem getSinglesCheckOutMenuItem() {
		if (singlesCheckOutMenuItem == null) {
			singlesCheckOutMenuItem = new JMenuItem();
			singlesCheckOutMenuItem.setText(Locale.get("MainWindow.singlesCheckOutMenuItem"));
			singlesCheckOutMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

						InfoPanel ipanel = new InfoPanel();

						IndividualCheckOutWindow individualCheckOutWindow =  IndividualCheckOutWindow.getInstance();					

						ipanel.setBounds(0,0,individualCheckOutWindow.getWidth(),50);
						ipanel.setInfoText(Locale.get("IndividualCheckOutWindow.infoText"));
						individualCheckOutWindow.setInfoPanel(ipanel);
						individualCheckOutWindow.setTitle(Locale.get("IndividualCheckOutWindow.title"));
						individualCheckOutWindow.setAdapter(new CheckOutCreator());

						showInDesktopPane(individualCheckOutWindow);

				}
			});

		}
		return singlesCheckOutMenuItem;
	}

	private JMenuItem getGroupsCheckOutMenuItem() {
		if (groupsCheckOutMenuItem == null) {
			groupsCheckOutMenuItem = new JMenuItem();
			groupsCheckOutMenuItem.setText(Locale.get("MainWindow.groupsCheckOutMenuItem"));
			groupsCheckOutMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

						InfoPanel ipanel = new InfoPanel();

						GroupCheckOutWindow groupCheckOutWindow =  GroupCheckOutWindow.getInstance();					

						ipanel.setBounds(0,0,groupCheckOutWindow.getWidth(),50);
						ipanel.setInfoText(Locale.get("GroupCheckOutWindow.infoText"));
						groupCheckOutWindow.setInfoPanel(ipanel);
						groupCheckOutWindow.setTitle(Locale.get("GroupCheckOutWindow.title"));
						groupCheckOutWindow.setAdapter(new CheckOutCreator());

						showInDesktopPane(groupCheckOutWindow);

				}
			});

		}
		return groupsCheckOutMenuItem;
	}

	/**
	 * This method initializes owesMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getOwesMenuItem() {
		if (owesMenuItem == null) {
			owesMenuItem = new JMenuItem();
			owesMenuItem.setText(Locale.get("MainWindow.owesMenuItem"));
			owesMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					InfoPanel ipanel = new InfoPanel();

					OweWindow oweWindow =  OweWindow.getInstance();					

					ipanel.setBounds(0,0,oweWindow.getWidth(),50);
					ipanel.setInfoText(Locale.get("OweWindow.infoText"));
					oweWindow.setInfoPanel(ipanel);
					oweWindow.setTitle(Locale.get("OweWindow.title"));					

					showInDesktopPane(oweWindow);	

				}
			});

		}
		return owesMenuItem;
	}

	private JMenuItem getRoomPlanningMenuItem() {
		if (roomPlanningMenuItem == null) {
			roomPlanningMenuItem = new JMenuItem();
			roomPlanningMenuItem.setText(Locale.get("MainWindow.roomPlanningMenuItem"));
			roomPlanningMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

						InfoPanel ipanel = new InfoPanel();

						RoomPlanningWindow roomPlanningWindow = RoomPlanningWindow.getInstance();

						roomPlanningWindow.setTitle(Locale.get("RoomPlanningWindow.title"));						

						ipanel.setBounds(0,0,roomPlanningWindow.getWidth(),50);
						ipanel.setInfoText(Locale.get("RoomPlanningWindow.infoText"));
						roomPlanningWindow.setInfoPanel(ipanel);							

						showInDesktopPane(roomPlanningWindow);

				}

			});
		}
		return roomPlanningMenuItem;
	}

	/**
	 * This method initializes invoicesMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getInvoicesMenuItem() {
		if (invoicesMenuItem == null) {
			invoicesMenuItem = new JMenuItem();
			invoicesMenuItem.setText(Locale.get("MainWindow.invoicesMenuItem"));
			invoicesMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					InfoPanel ipanel = new InfoPanel();

					InvoiceWindow invoiceWindow =  InvoiceWindow.getInstance();					

					ipanel.setBounds(0,0,invoiceWindow.getWidth(),50);
					ipanel.setInfoText(Locale.get("InvoiceWindow.infoText"));
					invoiceWindow.setInfoPanel(ipanel);
					invoiceWindow.setTitle(Locale.get("InvoiceWindow.title"));			
					invoiceWindow.setAdapter(new InvoiceCreator());

					showInDesktopPane(invoiceWindow);	

				}
			});

		}
		return invoicesMenuItem;
	}
	

	/**
	 * This method initializes paymentsMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getPaymentsMenuItem() {
		if (paymentsMenuItem == null) {
			paymentsMenuItem = new JMenuItem();
			paymentsMenuItem.setText(Locale.get("MainWindow.paymentsMenuItem"));
			paymentsMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					InfoPanel ipanel = new InfoPanel();

					PaymentWindow paymentWindow =  PaymentWindow.getInstance();					

					ipanel.setBounds(0,0,paymentWindow.getWidth(),50);
					ipanel.setInfoText(Locale.get("PaymentWindow.infoText"));
					paymentWindow.setInfoPanel(ipanel);
					paymentWindow.setTitle(Locale.get("PaymentWindow.title"));			
					paymentWindow.setAdapter(new PaymentCreator());

					showInDesktopPane(paymentWindow);	

				}
			});

		}
		return paymentsMenuItem;
	}
	
	/**
	 * This method initializes cashMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getCashMenuItem() {
		if (cashMenuItem == null) {
			cashMenuItem = new JMenuItem();
			cashMenuItem.setText(Locale.get("MainWindow.cashMenuItem"));
			cashMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					InfoPanel ipanel = new InfoPanel();

					CashWindow cashWindow =  CashWindow.getInstance();					

					ipanel.setBounds(0,0,cashWindow.getWidth(),50);
					ipanel.setInfoText(Locale.get("CashWindow.infoText"));
					cashWindow.setInfoPanel(ipanel);
					cashWindow.setTitle(Locale.get("CashWindow.title"));			
					cashWindow.setAdapter(new PaymentCreator());

					showInDesktopPane(cashWindow);	

				}
			});

		}
		return cashMenuItem;
	}
	
	public void showInDesktopPane(JInternalFrame frame) {

		if (frame.isIcon()) {
			try {
				frame.setIcon(false);
			} catch (PropertyVetoException e) {}
		} else {			 
			if (!frame.isVisible()) {								 
				getContentPane().remove(frame);
				getContentPane().add(frame);				
				frame.setVisible(true);		
			}
		}

		try {
			frame.setSelected(true);
		} catch (java.beans.PropertyVetoException e) {}

	}

}  //  @jve:decl-index=0:visual-constraint="10,4"
;