/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.view.swing.util.gui;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.swing.text.MaskFormatter;

/** Mascara para fecha/hora a nuestro gusto */
public class DateFormat extends MaskFormatter
{

	private static final long serialVersionUID = 1L;

	/** Se construye con el patrn deseado */
	public DateFormat() throws ParseException
	{
		// Las # son cifras y representa "dd/mm/yy hh:mm:ss"
		super ("##/##/####");
	}

	/** Una clase adecuada para convertir Date a String y viceversa de forma cmoda. Puedes ver cmo se hace el patrn "dd/MM/yy kk:mm:ss" en la API.
        El patrn que pongamos aqu debe cuadrar correctamente con la mscara que hemos puesto en el constructor */
	private SimpleDateFormat formato = new SimpleDateFormat("dd/MM/yyyy");

	/** Convierte el texto del editor en un Date */
	public Object stringToValue(String text) throws ParseException
	{
		return formato.parseObject(text);
	}

	/** Redibe un Date o null y debe convertirlo a texto que cumpla el patrn indicado anteriormente */
	public String valueToString(Object value) throws ParseException
	{
		if (value instanceof Date)
			return formato.format((Date)value);
		return formato.format(new Date());
	}
}