/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.view.swing.util.gui;

import javax.swing.text.*;
public class LimitDocument extends PlainDocument {

	private static final long serialVersionUID = 1L;
	private int limit;
	public LimitDocument(int limit) {
		super();
		setLimit(limit);  // store the limit    
	}
	public final int getLimit() {
		return limit;
	}
	public void insertString(int offset, String s, AttributeSet attributeSet) 
	throws BadLocationException {
		if(offset < limit) // if we haven't reached the limit, insert the string
		{
			super.insertString(offset,s,attributeSet);
		} // otherwise, just lose the string
	}
	public final void setLimit(int newValue) {
		this.limit = newValue;
	}
	
}
